import 'dart:async';

import 'package:clx_webview_flutter/utils/command.dart';
import 'package:clx_webview_flutter/utils/result.dart';
import 'package:webview_flutter/webview_flutter.dart';

import '../../clx_webview_flutter.dart';

typedef JavaScriptCallback = FutureOr<CLXResult<dynamic>> Function(
    JavaScriptMessage message);

class JavaScriptChannel {
  final String name;
  late CommandArgument<dynamic, JavaScriptMessage> channelCallback;

  JavaScriptChannel(
      {required this.name, required JavaScriptCallback callback}) {
    channelCallback = CommandArgument(callback);
  }

  @override
  operator ==(Object other) {
    if (other is JavaScriptChannel) {
      return name == other.name;
    }
    return false;
  }

  @override
  int get hashCode => super.hashCode;
}
